
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/epoll.h>

#include "utils.h"
#include "soket.h"
#include "http.h"
#include "swebs.h"

int sk;
int r;

char buf[2048];

char *dcgp_rqst =
"\
DCGP test HTTP/1.1\r\n\
Host: does.not.matter\r\n\
User-Agent: test-cong\r\n\
\r\n\
";

char frag_hdr[64+1];

char *dcgp_reply_tmpl =
"\
HTTP/1.1 %d %s\r\n\
Content-Length: %d\r\n\
\r\n\
%s\
";

char *body =
"<head>\n\
\t<title>DCGP TEST</title>\n\
</head>\n\
\n\
<body>\n\
<hr>\n\
<h1>It works!</h1>\n\
<hr>\n\
</body>\n\
";

char *default_server = "localhost:8888";
char *server;
struct job *job;

int epfd;
struct epoll_event poll4;

int main(int argc, char *argv[])
{

	struct epoll_event event;
	
	server = argv[1];
	if (!server)
		server = default_server;

	sk = soket_client(server);
	if (-1 == sk)
		exit(1);

	r = send(sk, dcgp_rqst, strlen(dcgp_rqst), 0);
	if (-1 == r) {
		perror("send()");
		exit(1);
	}

	// get response
	memset(buf, 0, sizeof(buf));
	r = recv(sk, buf, sizeof(buf), 0);
	printf("\n --- DCGP response <<<\n\n%s\n --- DCGP response >>>\n", buf);
	// parse response
	// если отлуп, отлипнуть

	epfd = epoll_create(8);
	if (-1 == r) {
		perror("epoll_create()");
		exit(1);
	}

	poll4.events = EPOLLIN;
	poll4.data.ptr = NULL;
	r = epoll_ctl(epfd, EPOLL_CTL_ADD, sk, &poll4);
	if (-1 == r) {
		perror("epoll_ctl()");
		exit(1);
	}

	while (1) {

		event.events = 0;
		r = epoll_wait(epfd, &event, 1, 1000);
		if (!r)
			continue;

		if (r < 0) {
			perror("epoll_wait()");
			// continue;
			exit(1);
		}

		job = swebs_new_job();
		job->sock = sk;

		// get request
		// memset(buf, 0, sizeof(buf));
		// r = recv(sk, buf, sizeof(buf), 0);

		r = swebs_get_request(job);
		if (r <= 0) {
			free(job);
			continue;
		};

		printf("request ---\n'%s'\n", job->hdr.buf);

		r = http_parse_request_header(job->hdr.buf, &job->hdr);
		strcpy(job->id, job->hdr.job_id);
		printf("job id : '%s'\n", job->id);

		job->buf = malloc(1024);
		memset(job->buf, 0, 1024);
		sprintf((char*)job->buf, dcgp_reply_tmpl, 200, "OK", strlen(body), body);

		memset(frag_hdr, 0, sizeof(frag_hdr));
		sprintf(frag_hdr, "%s:%.16llx\r\n", job->id, (unsigned long long)strlen((char*)job->buf));

		printf("sending frag hdr: '%s'", frag_hdr);
		send(sk, frag_hdr, 64, 0);

		printf("sending frag: '%s'", job->buf);
		send(sk, job->buf, 1024, 0);

		// send empty fragment....

		free(job->buf);
		free(job);
	};

	close(sk);
	return 0;
}
