
/*
	life easing wrappers around BSD sockets API (IPv4/TCP)
*/

#ifndef SWEBS_SOKET_H
#define SWEBS_SOKET_H

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define SERVER_SK 1
#define CLIENT_SK 2

int soket_server(unsigned short port, int accept_queue_len);

#define IP_STR_LEN 16
int soket_accept(int sk, char *ip, struct timeval *sndtimeo);

/* abc.def.net:1234 */
int soket_client(char *service);

int soket_read(int sk, unsigned char *buf, unsigned long len);
int soket_write(int sk, char *buf, size_t len);
int soket_close(int sk);

#endif
