
#define _XOPEN_SOURCE 500

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>

#include "utils.h"

void *insistent_zmalloc(size_t bytes)
{
	void *tmp = NULL;

	do {
		tmp = malloc(bytes);
		if (tmp)
			break;
		printf("insistent_zmalloc() _BEFORE_SLEEP_\n");
		sleep(1);
		printf("insistent_zmalloc()_AFTER_SLEEP_\n");
	} while(1);

	memset(tmp, 0, bytes);
	return tmp;
}

void zfree(void **ptr)
{
	if (*ptr)
		free(*ptr);
	*ptr = NULL;
}


/* There can really be cases of partial reads from disks! */
int insistent_filepread(int fd, unsigned char *buf, size_t len, off_t from)
{
	size_t bread = 0;
	int r;

	while (bread != len) {

		r = pread(fd, buf + bread, len - bread, from + bread);
		if (r > 0) {
			bread += r;
			// continue;
		} else {
			printf("!!!! FETCHER: error reading from %d\n", fd);
			perror("pread()");
			return 0;
		}
	};

	return len;
}


char *wkdays[7] = {
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat"
};

char *months[12] = {
	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",
	"Aug",
	"Sep",
	"Oct",
	"Nov",
	"Dec"
};

char *rfc1123_date_tmpl = "%3s, %.2d %3s %.4d %.2d:%.2d:%.2d GMT";

void rfc1123_date(time_t unixtime, char *tmstr)
{
	struct tm tm;

	gmtime_r(&unixtime, &tm);
	sprintf(
		tmstr,
		rfc1123_date_tmpl,
		wkdays[tm.tm_wday],
		tm.tm_mday,
		months[tm.tm_mon],
		1900 + tm.tm_year,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec
	);
}

void lay_pipe(int *p)
{
	int err;

	while (1) {
		err = pipe(p);
		if (-1 == err) {
			perror("pipe()");
			sleep(1);
			continue;
		} else
			break;
	}
}

void str_to_upper_case(char *s)
{
	int c;

	if (!s)
		return;

	for (c = 0; c < strlen(s); s[c] = toupper(s[c]), c++);
}
